
#include <LiquidCrystal.h>//wird für die Ansteuerung des Display benötigt.
#include <String.h>       //benötigt für Textfunktionen.
#include <Keypad.h>       //Keypad Library ist nicht standardmäßig hinterlegt. Muss im Arduino Verzeichnis manuell installiert werden. Library über Arduino.cc.

LiquidCrystal lcd(12, 11, 5, 4, 3, 2);

String inputString = "";         
boolean stringComplete = false;  

String linie_alt = "";

String text1;
String text2; 
String text3; 
String text4; 
String text5; 
String text6;
String text7; 
String text8; 
String text9;
String text10;
String text11;
String text12;
String text13;
String text14; 
String text15; 
String text16;

int cursor_an = 0;
int cursor_an_linie = 0;
int speicher_stelle_linie = 7;
int drucker_an = 0;

const byte ROWS = 5; //5 Zeilen
const byte COLS = 8; //8 Reihen


//Definition der Tasten. Beispiel Fahrscheindrucker oben links bekommt den interen Wert 0, dieser wird später abgefragt und löst ein Event aus. (z.B. Tastedruck in OMSI)
char hexaKeys[ROWS][COLS] = {
  {'0','1','2','3','5','6','7','8'},
  {'9','Z','a','b','c','d','e','f'},
  {'g','h','i','j','k','l','m','n'},
  {'o','p','r','s','t','u','v','w'},
  {'x','y','z','A','B','C','D','E'}
  
};

byte rowPins[ROWS] = {30, 31, 32, 34, 33}; 
byte colPins[COLS] = {22, 23, 24, 25, 26, 27, 28, 29}; 

Keypad customKeypad = Keypad( makeKeymap(hexaKeys), rowPins, colPins, ROWS, COLS); 

char B = B;
char ctrlKey = KEY_LEFT_CTRL;
char leftshift = KEY_LEFT_SHIFT;

void setup() {
  // serielle Kommunikation vorbereiten bzw. starten
  Serial.begin(115200);
  Serial.flush();  
  inputString.reserve(200);  
  Keyboard.begin();  
  
  inputString.reserve(200);      
  lcd.begin(40,2);
  pinMode(10, OUTPUT);
  digitalWrite(10, LOW); 
    lcd.setCursor(24, 0);
    lcd.print("|"); 
    lcd.setCursor(24, 1);
    lcd.print("|"); 
    lcd.setCursor(25, 0);
    lcd.print("Temperatur");
    lcd.setCursor(39, 0);  
    lcd.print((char)223);
    lcd.setCursor(25, 1);
    lcd.print("Uhrzeit");
}

void loop() {
if (stringComplete) {

  String split = inputString;    
    text1 = getValue(split, ',', 0); //Verspätung ja/nein
    text2 = getValue(split, ',', 1); //Linie kurz
    text3 = getValue(split, ',', 2); //Route
    text4 = getValue(split, ',', 3); //Haltestellenindex
    text5 = getValue(split, ',', 4); //Uhrzeit
    text6 = getValue(split, ',', 5); //Verspätungszeit
    text7 = getValue(split, ',', 6); //Haltestellenname
    text8 = getValue(split, ',', 7); //Zone
    text9 = getValue(split, ',', 8); //Ziel
    text10 = getValue(split, ',', 9); //Richtung
    text11 = getValue(split, ',', 10);//Linie komplett
    text12 = getValue(split, ',', 11);//Temp
    text13 = getValue(split, ',', 12);//Fahrkarte
    text13.replace(";", " ");
    inputString = "";
    stringComplete = false;

  
//Nachdem Daten über die serielle Schnittstelle empfangen werden, kommt nun die Aufteilung.
    if (cursor_an == 0)
    { //Ist dieser Wert 1 dann wird entweder die Linie, Route oder Ziel eingegeben.
    

     if (linie_alt == text7){ 
      lcd.setCursor(0, 0);
      lcd.print(linie_alt);
     }
     if (linie_alt != text7){
        lcd.setCursor(0, 0);
        lcd.print("                        "); 
        lcd.setCursor(0, 0);
        lcd.print(text7);      
      } 
       
      lcd.setCursor(37, 0);
      lcd.print(text12);
      
      lcd.setCursor(0, 1);
      lcd.print(text11);
      
      char rou_num[6];      
      text3.toCharArray(rou_num, sizeof(rou_num));
      int routennummer = atoi(rou_num);      
      lcd.setCursor(6, 1);        
         if (routennummer <10){
         String routennummer_ausgabe = "0" + text3;  
         lcd.print(routennummer_ausgabe)+" ";
         }
         if (routennummer >9){
         String routennummer_ausgabe = text3;  
         lcd.print(routennummer_ausgabe)+" ";
         }  
         
      lcd.setCursor(9, 1);
      lcd.print(text9);   
      lcd.setCursor(13, 1);
      lcd.print(text8); 
      lcd.setCursor(17, 1);
      lcd.print(text10);    
      lcd.setCursor(19, 1);
      lcd.print(text6);    
      lcd.setCursor(35, 1);
      lcd.print(text5); 
      delay(100);
    }
    if (drucker_an == 1)
    {
    lcd.setCursor(0, 0);
    lcd.print(text13);  
    }
linie_alt = text7;
}

char customKey = customKeypad.getKey();
  
  if (customKey == '0'){
    lcd.setCursor(0, 0);
    lcd.print("                        ");
    lcd.setCursor(0, 1);
    lcd.print("                        ");
    //lcd.clear();
    lcd.setCursor(0,0);
    lcd.print("Linie/Kurs eingeben");
    lcd.setCursor(0,1);    
    lcd.print("Linie: _____");
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press(KEY_F1);  
    cursor_an_linie = 1;
    cursor_an = 1;
    speicher_stelle_linie = 7;
    delay(100);
    Keyboard.releaseAll(); 
  }

  if (customKey == '9'){
    lcd.setCursor(0, 0);
    lcd.print("                        ");
    lcd.setCursor(0, 1);
    lcd.print("                        ");
    //lcd.clear();
    lcd.setCursor(0,0);
    lcd.print("Route eingeben");
    lcd.setCursor(0,1);    
    lcd.print("Route: __");
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press(KEY_F2);  
    cursor_an_linie = 1;
    cursor_an = 1;
    speicher_stelle_linie = 7;
    delay(100);
    Keyboard.releaseAll(); 
  }

  if (customKey == 'g'){
    lcd.setCursor(0, 0);
    lcd.print("                        ");
    lcd.setCursor(0, 1);
    lcd.print("                        ");
    //lcd.clear();
    lcd.setCursor(0,0);
    lcd.print("Ziel eingeben");
    lcd.setCursor(0,1);    
    lcd.print("Ziel:  ___");
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press(KEY_F3); 
    cursor_an_linie = 1;
    cursor_an = 1;
    speicher_stelle_linie = 7;
    delay(100);
    Keyboard.releaseAll(); 
  }

  if (customKey == '2')
  {
    lcd.setCursor(speicher_stelle_linie,1);    
    lcd.print("7");
    speicher_stelle_linie = speicher_stelle_linie + 1;
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press(KEY_F4); 
    delay(100);
    Keyboard.releaseAll();     
  }
  if (customKey == '3')
  {
    lcd.setCursor(speicher_stelle_linie,1);    
    lcd.print("8");
    speicher_stelle_linie = speicher_stelle_linie + 1;
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press(KEY_F5); 
    delay(100);
    Keyboard.releaseAll();   

  }
  if (customKey == '5')
  {
    lcd.setCursor(speicher_stelle_linie,1);    
    lcd.print("9");
    speicher_stelle_linie = speicher_stelle_linie + 1;
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press(KEY_F6); 
    delay(100);
    Keyboard.releaseAll();   
  }
  if (customKey == 'a')
  {
    lcd.setCursor(speicher_stelle_linie,1);    
    lcd.print("4");
    speicher_stelle_linie = speicher_stelle_linie + 1;
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press(KEY_F7); 
    delay(100);
    Keyboard.releaseAll();   
  }
  if (customKey == 'b')
  {
    lcd.setCursor(speicher_stelle_linie,1);    
    lcd.print("5");
    speicher_stelle_linie = speicher_stelle_linie + 1;
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press(KEY_F8); 
    delay(100);
    Keyboard.releaseAll();   
  }
  if (customKey == 'c')
  {
    lcd.setCursor(speicher_stelle_linie,1);    
    lcd.print("6");
    speicher_stelle_linie = speicher_stelle_linie + 1;
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press(KEY_F9); 
    delay(100);
    Keyboard.releaseAll();   
  } 
  if (customKey == 'i')
  {
    lcd.setCursor(speicher_stelle_linie,1);    
    lcd.print("1");
    speicher_stelle_linie = speicher_stelle_linie + 1;
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press(KEY_F10); 
    delay(100);
    Keyboard.releaseAll();   
  }
  if (customKey == 'j')
  {
    lcd.setCursor(speicher_stelle_linie,1);    
    lcd.print("2");
    speicher_stelle_linie = speicher_stelle_linie + 1;
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press(KEY_PAGE_UP); 
    delay(100);
    Keyboard.releaseAll();   
  }
  if (customKey == 'k')
  {
    lcd.setCursor(speicher_stelle_linie,1);    
    lcd.print("3");
    speicher_stelle_linie = speicher_stelle_linie + 1;
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press(KEY_F12); 
    delay(100);
    Keyboard.releaseAll();   
  } 
  if (customKey == 'A') //Taste 0
  {
    lcd.setCursor(speicher_stelle_linie,1);    
    lcd.print("0");
    speicher_stelle_linie = speicher_stelle_linie + 1;
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press(KEY_PAGE_DOWN); 
    delay(100);
    Keyboard.releaseAll(); 
  } 
  if (customKey == 'B') //Taste Auslösen
  {
    if (drucker_an == 0){
   cursor_an_linie = 0;
   cursor_an = 0;
   speicher_stelle_linie=0;   
    lcd.setCursor(0, 0);
    lcd.print("                        ");
    lcd.setCursor(0, 1);
    lcd.print("                        ");
    //delay(100);
    lcd.setCursor(24, 0);
    lcd.print("|"); 
    lcd.setCursor(24, 1);
    lcd.print("|"); 
    lcd.setCursor(25, 0);
    lcd.print("Temperatur");
    lcd.setCursor(39, 0);  
    lcd.print((char)223);
    lcd.setCursor(25, 1);
    lcd.print("Uhrzeit");}
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press('f');  
    delay(100);
    Keyboard.releaseAll();     
    if (drucker_an == 1){
    lcd.setCursor(0, 0);
    lcd.print("Druckt...            ");  
    delay(600);
    drucker_an = 0;
     cursor_an_linie = 0;
     cursor_an = 0;
     speicher_stelle_linie=0; 
     
    }
  }  
  if (customKey == 'z') //C Taste Abbruch
  {
   cursor_an_linie = 0;
   cursor_an = 0;
   speicher_stelle_linie=0;    
    lcd.setCursor(0, 0);
    lcd.print("                        ");
    lcd.setCursor(0, 1);
    lcd.print("                        ");
    //delay(100);
    lcd.setCursor(24, 0);
    lcd.print("|"); 
    lcd.setCursor(24, 1);
    lcd.print("|"); 
    lcd.setCursor(25, 0);
    lcd.print("Temperatur");
    lcd.setCursor(39, 0);  
    lcd.print((char)223);
    lcd.setCursor(25, 1);
    lcd.print("Uhrzeit");
    if (drucker_an == 1){
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press('g');  
    delay(100);
    Keyboard.releaseAll(); 
    drucker_an = 0;
     cursor_an_linie = 0;
     cursor_an = 0;
     speicher_stelle_linie=0; 
    }
  }  

  if (customKey == '6')
  {
    cursor_an_linie = 0;
    cursor_an = 0;
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press('a');
    lcd.setCursor(0, 0);
    lcd.print("                        ");
    lcd.setCursor(0, 1);
    lcd.print("                        "); 
    //lcd.setCursor(0, 0);
    //lcd.print(text13);    
    cursor_an_linie = 1;
    cursor_an = 1;
    drucker_an = 1;
    delay(100);
    Keyboard.releaseAll();
  }  
  if (customKey == 'd')
  {
    cursor_an_linie = 0;
    cursor_an = 0;
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press('b');
    lcd.setCursor(0, 0);
    lcd.print("                        ");
    lcd.setCursor(0, 1);
    lcd.print("                        "); 
    //lcd.setCursor(0, 0);
    //lcd.print(text13);    
    cursor_an_linie = 1;
    cursor_an = 1;
    drucker_an = 1;
    delay(100);
    Keyboard.releaseAll();
  } 
  if (customKey == 'u')
  {
    cursor_an_linie = 0;
    cursor_an = 0;
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press('c');
    lcd.setCursor(0, 0);
    lcd.print("                        ");
    lcd.setCursor(0, 1);
    lcd.print("                        "); 
    //lcd.setCursor(0, 0);
    //lcd.print(text13);    
    cursor_an_linie = 1;
    cursor_an = 1;
    drucker_an = 1;
    delay(100);
    Keyboard.releaseAll();
  } 
  if (customKey == 'l')
  {
    cursor_an_linie = 0;
    cursor_an = 0;
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press('d');
    lcd.setCursor(0, 0);
    lcd.print("                        ");
    lcd.setCursor(0, 1);
    lcd.print("                        "); 
    //lcd.setCursor(0, 0);
    //lcd.print(text13);    
    cursor_an_linie = 1;
    cursor_an = 1;
    drucker_an = 1;
    delay(100);
    Keyboard.releaseAll();
  } 
  if (customKey == 'C')
  {
    cursor_an_linie = 0;
    cursor_an = 0;
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press('e');
    lcd.setCursor(0, 0);
    lcd.print("                        ");
    lcd.setCursor(0, 1);
    lcd.print("                        "); 
    //lcd.setCursor(0, 0);
    //lcd.print(text13);    
    cursor_an_linie = 1;
    cursor_an = 1;
    drucker_an = 1;
    delay(100);
    Keyboard.releaseAll();
  } 

  if (customKey == 'y')
  {
    Keyboard.press(ctrlKey);
    Keyboard.press('o'); 
    delay(100);
    Keyboard.releaseAll();   
  }
  if (customKey == 'x')
  {
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press('v'); 
    delay(100);
    Keyboard.releaseAll();   
  }
  if (customKey == '1')
  {
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press('t'); 
    delay(100);
    Keyboard.releaseAll();   
  }
  if (customKey == 'z')
  {
    Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press('t'); 
    delay(100);
    Keyboard.releaseAll();   
  }
  if (customKey == 'Z')
  {
    Keyboard.press(leftshift);
    //Keyboard.press(ctrlKey);
    Keyboard.press('t'); 
    delay(100);
    Keyboard.releaseAll();   
  }
  if (customKey == '7')
  {
    //Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press('6'); 
    delay(100);
    Keyboard.releaseAll();   
  }
  
  if (customKey == 'e')
  {
    //Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press('7'); 
    delay(100);
    Keyboard.releaseAll();   
  }
  
  if (customKey == 'm')
  {
    //Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press('8'); 
    delay(100);
    Keyboard.releaseAll();   
  }
  if (customKey == 'v')
  {
    //Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press('9'); 
    delay(100);
    Keyboard.releaseAll();   
  }
  if (customKey == 'D')
  {
    //Keyboard.press(leftshift);
    Keyboard.press(ctrlKey);
    Keyboard.press('0'); 
    delay(100);
    Keyboard.releaseAll();   
  }

}

void serialEvent() {
  while (Serial.available()) {
    char inChar = (char)Serial.read();
    inputString += inChar;
    if (inChar == '\;') {
      stringComplete = true;
    }
  }
}
 
 String getValue(String data, char separator, int index)
{
  int found = 0;
  int strIndex[] = {0, -1};
  int maxIndex = data.length()-1;

  for(int i=0; i<=maxIndex && found<=index; i++){
    if(data.charAt(i)==separator || i==maxIndex){
        found++;
        strIndex[0] = strIndex[1]+1;
        strIndex[1] = (i == maxIndex) ? i+1 : i;
    }
  }

  return found>index ? data.substring(strIndex[0], strIndex[1]) : "";
}



